=== tests/test/dependencies-d/Portfile ===
# -*- coding: utf-8; mode: tcl; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4

PortSystem      1.0

name            dependencies-d
version         1
categories      test
maintainers     pguyot@kallisys.net
description     Test port for dependencies
homepage        https://www.macports.org/
platforms       darwin
supported_archs noarch
configure.cxx_stdlib

long_description ${description}

distfiles
use_configure   no
build           {}
destroot {
    system "touch ${destroot}${prefix}/lib/${name}"
}

# Check that macports doesn't chunk on this junk.
# This might mean this port depends on port dependencies-a without variant
# i_want_b (which is a default variant).
depends_lib     port:-i_want_b:dependencies-a

# Check that macports doesn't chunk on this junk, but just generates a warning.
depends {configure {dependencies-a +i_want_b >= 1}}

test {
    # testing consists in processing dependencies
}
